package io.accumulatenetwork.sdk.generated.protocol;

/**
    GENERATED BY go run ./tools/cmd/gen-api. DO NOT EDIT.
**/

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonTypeName;
import io.accumulatenetwork.sdk.generated.managed.ChainType;
import io.accumulatenetwork.sdk.protocol.Marshallable;
import io.accumulatenetwork.sdk.support.Marshaller;
// UnionType: 
// UnionValue: 

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonTypeName("ChainMetadata")
@JsonInclude(JsonInclude.Include.NON_NULL)
public class ChainMetadata implements Marshallable {
	private String name;
	private ChainType type;

    //
	public String getName() {
	    return name;
	}
	public void setName(final String value) {
	    this.name = value;
	}

	public ChainMetadata name(final String value) {
	    setName(value);
	    return this;
	}
	public ChainType getType() {
	    return type;
	}
	public void setType(final ChainType value) {
	    this.type = value;
	}

	public ChainMetadata type(final ChainType value) {
	    setType(value);
	    return this;
	}
    public byte[] marshalBinary() {
        final var marshaller = new Marshaller();
        if (!(this.name == null || this.name.length() == 0)) {
            marshaller.writeString(1, this.name);
        }
        if (!(this.type == null)) {
            marshaller.writeValue(2, type);
        }
        return marshaller.array();
    }
}
